# HCMGIS - Basemap, Vn-2000 Projections, Geometry Processing and Field Calculation plugin for QGIS3

**HCMGIS** is a set of useful geometry processing and field calculation utilities:


**- Basemap**: Add dozens of global basemaps from Carto, ESRI, Google, OSM Stamen, HCMGIS Aerial Images,...

**- HCMGIS OpenData**:  Download free and open geodata from https://opendata.hcmgis.vn

**- Vn-2000 Projections**:  Define local UTM projections for each provinces of VietNam in Vn-2000 Coordinate Reference System


**- Spatial Processing**: 

+ Create Skeleton/Medial Axis/ Centerline for road/ river networks and similar linear structures (layers must be in projected coordinate reference system)
+ Create Centerline in Polygon's gaps (E.g building blocks) (layers must be in projected coordinate reference system)
+ Finding closest/ farthest pair of Points in a Point set based on Voronoi Diagram
+ Finding Largest Empty Circle of a Point set.
+ Merging layers (with the same geometry type), split Layer (based on unique field),...

**- Attribute Calculation**: merge/ split data fields, Vietnamese Font Converter: Unicode <-> TCVN3 <-> Vni-Windows, UPPER CASE, lower case,...

**- Batch Converter**: Batch convert XY to Point (CSV to Shapefile) in a folder and its subfolders

# 

**HCMGIS** là QGIS3 plugin cung cấp một số công cụ xử lý hình học và thuộc tính:


**- Basemap**: Thêm bản đồ nền Carto, ESRI, Google, OSM Stamen, HCMGIS Aerial Images,...trong QGIS

**- HCMGIS OpenData**:  Download miễn phí dữ liệu GIS từ https://opendata.hcmgis.vn

**- Vn-2000 Projections**:  Định nghĩa hệ tọa độ địa phương cho các tỉnh/ thành ở Việt Nam


**-Xử lý không gian**: 
+ Tạo xương (skeleton/ medial axis/ Centerline) cho đối tượng dạng vùng (mạng giao thông/ sông rạch) (Layer dạng vùng phải ở dạng projected coordinate reference system)
+ Tạo Centerline (tim hẻm, đường phân phối điện/ nước) cho các block nhà (Layer Block nhà phải ở dạng projected coordinate reference system)
+ Tìm cặp điểm gần nhất/ xa nhất cho một tập điểm dựa trên Voronoi Diagram
+ Tìm đường tròn rỗng lớn nhất (không chứa bất cứ điểm nào) của một tập điểm
+ Gộp layers, tách layer.

**-Xử lý thuộc tính**: Gộp/ tách trường dữ liệu, chuyển đổi font chữ tiếng Việt Unicode <--> TCVN3 <--> Vni-Windows, với các tiện ích IN HOA, Hoa Mỗi Từ, Hoa đầu câu, in thường, khong dau.

**- Batch Converter**: Chuyển đổi tất cả các file XY (.csv) sang dạng điểm (shapefile) cho thư mục và các thư mục con